config/routes.rb
Rails.application.routes.draw do
  resources :emojis
  devise_for :users
  resources :users
 	resources :messages

	# Home page as root
  root 'home#home'

  # Contact page
  get '/contact' => 'contact#contact'
  post 'request_contact' => 'contact#request_contact'

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/emoji.rb
class Emoji < ApplicationRecord
	validates :name, :img_url, presence: true
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :user
  validates :user, :message, presence: true
end

app/models/user.rb
class User < ApplicationRecord
	has_many :messages, dependent: :destroy
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/contact_controller.rb
class ContactController < ApplicationController
  def request_contact
  	name = params[:name]
  	email = params[:email]
  	message = params[:message]

  	if name.blank? || message.blank? || email.blank?
  		flash[:alert] = I18n.t('contact.request_contact.missing_field')
  	else
      ContactMailer.contact_email(name, email, message).deliver_now
  		flash[:notice] = I18n.t('home.request_contact.email_sent')
  	end

  	redirect_to root_path
  end
end

app/controllers/emojis_controller.rb
class EmojisController < ApplicationController
  before_action :set_emoji, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!

  # GET /emojis
  # GET /emojis.json
  def index
    @emojis = Emoji.all
  end

  # GET /emojis/1
  # GET /emojis/1.json
  def show
  end

  # GET /emojis/new
  def new
    @emoji = Emoji.new
  end

  # GET /emojis/1/edit
  def edit
  end

  # POST /emojis
  # POST /emojis.json
  def create
    @emoji = Emoji.new(emoji_params)

    respond_to do |format|
      if @emoji.save
        format.html { redirect_to emojis_path, notice: 'Emoji was successfully created.' }
        format.json { render :show, status: :created, location: @emoji }
      else
        format.html { render :new }
        format.json { render json: @emoji.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /emojis/1
  # PATCH/PUT /emojis/1.json
  def update
    respond_to do |format|
      if @emoji.update(emoji_params)
        format.html { redirect_to @emoji, notice: 'Emoji was successfully updated.' }
        format.json { render :show, status: :ok, location: @emoji }
      else
        format.html { render :edit }
        format.json { render json: @emoji.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /emojis/1
  # DELETE /emojis/1.json
  def destroy
    @emoji.destroy
    respond_to do |format|
      format.html { redirect_to emojis_url, notice: 'Emoji was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_emoji
      @emoji = Emoji.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def emoji_params
      params.require(:emoji).permit(:name, :description, :img_url)
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
	before_action :authenticate_user!
  def home
    @message = Message.new
  end
end

app/controllers/messages_controller.rb
class MessagesController < ApplicationController
  before_action :authenticate_user!

  # GET /messages
  # GET /messages.json
  def index
    @messages = Message.order('created_at ASC')
    respond_to do |format|
      format.html { render :index }
      format.json { render json: @messages }
    end
  end

  # GET /messages/new
  def new
    redirect_to messages_url
  end

  # POST /messages
  # POST /messages.json
  def create
    @message = Message.new(message_params)
    @message.user = current_user

    respond_to do |format|
      if @message.save
        format.html { redirect_to messages_url, notice: 'Message was successfully created.' }
        format.js { flash[:notice] = 'Message was successfully created.' }
        format.json { render :show, status: :created, location: @message }
      else
        format.html { render :new }
        format.json { render json: @message.errors, status: :unprocessable_entity }
      end
    end
  end
  
  private
    # Never trust parameters from the scary internet, only allow the white list through.
    def message_params
      params.require(:message).permit(:message)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/contact_helper.rb
module ContactHelper
end

app/helpers/emojis_helper.rb
module EmojisHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/messages_helper.rb
module MessagesHelper
end

app/views/contact/contact.html.haml
.row#intro
	.col-md-12
		%h2= t(".title")
		%h5= t(".description")

.row#form
	.col-md-12
		= form_tag request_contact_path, method: 'post' do
			.col-md-12
				= label_tag :name, t('.name_label')
				= text_field_tag :name, '', title: t('name_placeholder'), required: :true

			.col-md-12
				= label_tag :email, t('.email_label')
				= email_field_tag :email, '', title: t('email_placeholder'), required: :true

			.col-md-12
				= label_tag :message, t('.message_label')
				= text_area_tag :message, '', title: t('message_placeholder'), size: 100, required: :true

			.col-md-12
				= submit_tag t('.submit_button')

app/views/emojis/_form.html.haml
= form_for @emoji do |f|
  .field
    = f.label :name
    = f.text_field :name, required: true
  .field
    = f.label :description
    = f.text_field :description
  .field
    = f.label :img_url
    = f.text_field :img_url, required: true
  .actions
    = f.submit t('.save_emoji')

app/views/emojis/edit.html.haml
%h1 Editing emoji

= render 'form'

= link_to 'Show', @emoji
\|
= link_to 'Back', emojis_path

app/views/emojis/index.html.haml
%h1 Emojis

.row#headers
  .col-xs-2
    %p Name
  .col-xs-3
    %p Description
  .col-xs-4#img-url
    %p url

.row
  - @emojis.each do |emoji|
    .col-xs-2
      %p= emoji.name
    .col-xs-3
      %p= emoji.description
    .col-xs-4#img-url
      %p= emoji.img_url
    .col-xs-1
      %p= link_to 'Show', emoji
    .col-xs-1
      %p= link_to 'Edit', edit_emoji_path(emoji)
    .col-xs-1
      %p= link_to 'Destroy', emoji, :method => :delete, :data => { :confirm => 'Are you sure?' }

%br

= link_to 'New Emoji', new_emoji_path

app/views/emojis/new.html.haml
%h1 New emoji

= render 'form'

= link_to 'Back', emojis_path

app/views/emojis/show.html.haml
%p#notice= notice

%p
  %b Name:
  = @emoji.name
%p
  %b Description:
  = @emoji.description
%p
  %b url:
  = @emoji.img_url

%p
  %b Image:
  = image_tag (@emoji.img_url)

= link_to 'Edit', edit_emoji_path(@emoji)
\|
= link_to 'Back', emojis_path

app/views/home/home.html.haml
.row
	.col-xs-12#chatbox

.row
	.col-xs-12#message_box
		.row
			=render "messages/form"

app/views/layouts/application.html.haml
!!!

%html
	%head
		%meta{'charset' => 'utf-8'}
		%meta{'http-equiv' => 'x-ua-compatible', 'content' => 'ie=edge'}

		%title= t('app_title')

		%meta{'name' => 'description', 'content' => t('app_description')}
		%meta{'name' => 'viewport', 'content' => 'width=device-width, initial-scale=1'}

		= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true
		= javascript_include_tag 'application', 'data-turbolinks-track' => true
		= javascript_include_tag 'modernizr'
		= csrf_meta_tags

	%body
		= render 'shared/header'
		.container
			= yield
		= render 'shared/footer'

app/views/messages/_form.html.haml
= form_for Message.new, remote: true do |f|
  .field.col-xs-9
    = f.text_area :message, id: 'message', required: true
  .field
    = f.hidden_field :user_id, value: current_user.id
  .actions.col-xs-3
    = f.submit t('.send_message'), id: 'submit_message'

app/views/messages/create.js.haml
$('#message').val("")

app/views/messages/index.html.haml
%h1= t('.heading')
.row#headers
  .col-xs-2
    %p= t('.user_column_heading')
  .col-xs-10
    %p= t('.message_column_heading')


.row
  - @messages.each do |message|
    .col-xs-12
      %p= message.user.email + ': ' + message.message

app/views/shared/_footer.html.haml
%footer
	%p!= "&copy; #{t('app_title')} #{Time.now.year}"

app/views/shared/_header.html.haml
%header
	.navbar.navbar-default
		.container-fluid
			.collapse.navbar-collapse#bs-example-navbar-collapse-1
				%ul.nav.navbar-nav.navbar-left
					%li= link_to t('app_title'), root_path, id: "title"
				%ul.nav.navbar-nav.navbar-right
					- if user_signed_in?
						%li= link_to t('.welcome_user') + ' ' + current_user.email, edit_user_registration_path
						%li= link_to t('.home_link'), root_path
						%li= link_to t('.messages_link'), messages_path
						%li= link_to t('.emojis_link'), emojis_path
						%li= link_to t('.profile_link'), edit_user_registration_path
						%li= link_to t('.logout_link'), destroy_user_session_path, method: 'delete'
					- else		
						%li= link_to t('.home'), '/'
						%li= link_to t('.login_link'), new_user_session_path
						%li= link_to t('.signup_link'), new_user_registration_path
					%li= link_to t('.contact_link'), '/contact'

.container
	.row
		.col-md-12
			- flash.each do |key, value|
				= content_tag :div, content_tag(:p, value), id: "#{key}" unless value.blank?